using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using Microsoft.AspNetCore.Authorization;
using System.Web;
using MySystem.Models.Main;
using LitJson;
using Library;
using System.Data;
using MySystem.Service.Main;

namespace MySystem.Areas.Api.Controllers.v1
{
    [Area("Api")]
    [Route("Api/v1/[controller]/[action]")]
    public class ConsumerOrdersController : BaseController
    {
        public ConsumerOrdersController(IHttpContextAccessor accessor) : base(accessor)
        {
        }

        #region 消费者-支付接口
        // [Authorize]
        public JsonResult Pay(string value)
        {
            if (string.IsNullOrEmpty(value))
            {
                System.IO.StreamReader sr = new System.IO.StreamReader(Request.Body);
                value = sr.ReadToEnd();
                value = value.Split('=')[1];
            }
            // value = DesDecrypt(value);
            JsonData data = JsonMapper.ToObject(value);
            string SnNo = data["Sn"].ToString(); //商户
            string Machine = data["Machine"].ToString();
            int PayMode = int.Parse(function.CheckInt(data["PayMode"].ToString())); //支付方式(1 支付宝 2 微信)
            decimal PayMoney = decimal.Parse(function.CheckNum(data["PayMoney"].ToString())); //支付金额
            string Code = data["Code"].ToString();
            if (string.IsNullOrEmpty(data["PayMode"].ToString()))
            {
                return Json(new AppResultJson() { Status = "-1", Info = "请填写支付方式" });
            }
            if (string.IsNullOrEmpty(data["PayMoney"].ToString()))
            {
                return Json(new AppResultJson() { Status = "-1", Info = "请填写支付金额" });
            }
            if (!function.IsNum(data["PayMoney"].ToString()))
            {
                return Json(new AppResultJson() { Status = "-1", Info = "请填写正确的支付金额" });
            }
            if(SnNo.Length > 20)
            {
                SnNo = System.Web.HttpUtility.UrlDecode(SnNo);
                if(!SnNo.EndsWith("="))
                {
                    SnNo += "=";
                }
                SnNo = dbconn.Decrypt3DES(SnNo, "l2k0b2#3");
                SnNo = SnNo.TrimEnd('\0');
                SnNo = SnNo.Substring(0, SnNo.Length - 8);
            }
            var qrcode = MerchantQrCodeService.Query(" SnNo='" + SnNo + "'");
            var merchant = MerchantInfoService.Query(qrcode.MerchantId);
            var merchantAdd = MerchantAddInfoService.Query(qrcode.MerchantId);
            var merchantset = MerchantParamSetService.Query(qrcode.MerchantId);
            var ledgerModel = merchantset.IsAll == 1 ? "1" : "5";
            string openid = "";
            if (PayMode == 1)
            {
                openid = new AlipayFunction(_accessor.HttpContext).GetAlipayUserId(Code);
                if (openid.Contains("|"))
                {
                    openid = openid.Split('|')[0];
                }
            }
            else
            {
                string result = function.GetWebRequest("https://api.weixin.qq.com/sns/jscode2session?appid=" + new WeChatFunction().AppId + "&secret=" + new WeChatFunction().AppSecret + "&js_code=" + Code + "&grant_type=authorization_code");
                function.WriteLog(DateTime.Now.ToString() + "\n" + result, "微信小程序获取openid");
                JsonData jsonObj = JsonMapper.ToObject(result);
                openid = jsonObj["openid"].ToString();
            }
            int ConsumerId = 0;
            var check = ConsumerOpenIdsService.Exist(openid);
            if (check == false)
            {
                var info = ConsumersUtil.AddConsumers(ConsumerId, openid);
                ConsumerId = int.Parse(info.Data.ToString());
                ConsumerOpenIdsUtil.AddConsumerOpenIds(ConsumerId, openid);
            }
            else
            {
                var info = ConsumerOpenIdsService.Query(" OpenId='" + openid + "'");
                ConsumerId = info.ConsumerId;
            }
            Dictionary<string, object> Obj = new Dictionary<string, object>();
            string OrderNo = DateTime.Now.ToString("yyyyMMddHHmmssfff") + function.get_Random(8);
            bool ActFlag = merchantset.IsAll == 1 ? false : true;
            if (PayMoney < merchantset.MinPayMoney) //支付金额小于活动最小金额，则不分账
            {
                ActFlag = false;
            }
            var infos = ConsumerOrdersUtil.AddConsumerOrders(qrcode.MerchantId, ConsumerId, merchant.UserId, PayMode, PayMoney, SnNo, OrderNo, ActFlag ? PayMoney * merchantset.DiviPercent / 100 : 0, ActFlag ? 1u : 0u, ActFlag ? PayMoney * merchantset.GetPercent / 100 : PayMoney, Newtonsoft.Json.JsonConvert.SerializeObject(merchantset));
            ConsumerOrderForNoUtil.AddConsumerOrderForNo(OrderNo, int.Parse(infos.Data.ToString()));
            if (PayMode == 1)
            {
                string backString = HaoDaHelper.Instance.Alipay(merchantAdd.OutMchtNo, merchantAdd.StoreNo, OrderNo, PayMoney, SpHost + "/api/alipay/hdnotice", openid, function.get_Random(4), ledgerModel);
                JsonData obj = JsonMapper.ToObject(backString);
                if (obj["resultCode"].ToString() == "1")
                {
                    string tradeNo = obj["prePayId"].ToString();
                    Obj.Add("respCode", obj["resultCode"].ToString());
                    Obj.Add("tradeNo", tradeNo);
                }
                else
                {
                    Obj.Add("respCode", obj["resultCode"].ToString());
                    Obj.Add("tradeNo", "");
                    return Json(new AppResultJson() { Status = "-1", Info = obj["errorDesc"].ToString(), Data = Obj });
                }
            }
            else if (PayMode == 2)
            {
                var dic = JsonMapper.ToObject(HaoDaHelper.Instance.WeChatPay(merchantAdd.OutMchtNo, merchantAdd.StoreNo, OrderNo, PayMoney, SpHost + "/api/wechat/hdnotice", openid, function.get_Random(4), AppConfig.WeChat.AppId, "MINI_PROGRAM", ledgerModel));
                Obj.Add("appId", dic["payInfo"]["appId"].ToString()); //微信小程序appid
                Obj.Add("timeStamp", dic["payInfo"]["timeStamp"].ToString()); //时间戳
                Obj.Add("nonceStr", dic["payInfo"]["nonceStr"].ToString()); //随机字符串
                Obj.Add("package", dic["payInfo"]["wxPackage"].ToString()); //统一支付接口返回的prepayid参数值
                Obj.Add("paySign", dic["payInfo"]["paySign"].ToString()); //支付签名
                Obj.Add("ConsumerId", ConsumerId);
            }
            return Json(new AppResultJson() { Status = "1", Info = "", Data = Obj });
        }
        #endregion

    }
}
